unit CnCodeFormatReg;

interface

uses
  ToolsAPI,Forms;

function InitWizard(const BorlandIDEServices: IBorlandIDEServices;
  RegisterProc: TWizardRegisterProc;
  var Terminate: TWizardTerminateProc): Boolean; stdcall;

implementation

uses CnCodeFormatExpert;

const
  InvalidIndex = -1;

var
  ExpertIndex: Integer = InvalidIndex;

procedure TerminateWizard;
var
  Services: IOTAWizardServices;
begin
  Services := BorlandIDEServices as IOTAWizardServices;
  Services.RemoveWizard(ExpertIndex);
end;

function InitWizard(const BorlandIDEServices: IBorlandIDEServices;
  RegisterProc: TWizardRegisterProc;
  var Terminate: TWizardTerminateProc): Boolean; stdcall;
var
  WizardServices: IOTAWizardServices;
begin
  Result := (BorlandIDEServices <> nil);

  if Result then
    begin
      Assert(ToolsAPI.BorlandIDEServices = BorlandIDEServices);

      Terminate := TerminateWizard;

      WizardServices := BorlandIDEServices as IOTAWizardServices;
      Assert(Assigned(WizardServices));

      IDETextExpert := TIDETextExpert.Create;
      ExpertIndex := WizardServices.AddWizard(IDETextExpert as IOTAWizard);
      Result := (ExpertIndex >= 0);
    end;
end;

exports
  InitWizard name WizardEntryPoint;

end.

