unit CnIDEStream;

interface

uses
  Windows, SysUtils, Messages, Classes, ToolsAPI;

type
  TIDEStream = class(TMemoryStream)
  private
    FLines: TStringList;
    FFileName: string;
    function GetLines: TStringList;
    procedure SetLines(NewValue: TStringList);
  protected
  public
    constructor Create(AFileName: string);
    destructor Destroy; override;
    procedure WriteText(Text: string);
    property Capacity;
    property Lines: TStringList read GetLines write SetLines;
    property FileName: string read FFileName;
    procedure Clear;
  end;

implementation
uses Dialogs, Forms, Menus, StdCtrls, ComCtrls, CnOTAUtils;

constructor TIDEStream.Create(AFileName: string);
begin
  inherited Create;
  if AFileName = '' then
    begin
      FFileName := OtaGetCurrentSourceFile;
    end
  else
    FFileName := AFileName;
  if LowerCase(ExtractFileExt(FFileName)) = '.dfm' then
    raise Exception.Create('Sorry, must be a PAS or DPR file');
  FLines := TStringList.Create;
end;

procedure TIDEStream.Clear;
begin
  FLines.Clear;
  inherited Clear;
end;

destructor TIDEStream.Destroy;
begin
  FLines.Free;
  inherited Destroy;
end;

procedure TIDEStream.WriteText(Text: string);
begin
  OtaSettringAsActiveEditorText(Text);
end;

function TIDEStream.GetLines: TStringList;
var
  s: string;
begin
  if FLines.Count = 0 then
    begin
      OtaGetActiveEditorTextAsString(s, False);
      FLines.Text := s;
    end;
  Result := FLines;
end;

procedure TIDEStream.SetLines(NewValue: TStringList);
begin
  FLines.Assign(NewValue);
end;

end.
