unit frmCnCFProcessing;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, TlHelp32;

type
  TFormCnCFProcessing = class(TForm)
    lblMsg: TLabel;
    tmrFormatting: TTimer;
    procedure tmrFormattingTimer(Sender: TObject);
  private
    procedure SetFileName(const Value: string);
    { Private declarations }
  public
    property FileName: string write SetFileName;
  end;

var
  FormCnCFProcessing: TFormCnCFProcessing;

implementation

{$R *.dfm}

function TaskExists(TaskName: string): Boolean;
const
  PROCESS_TERMINATE = $0001;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  Result := False;

  FSnapshotHandle        := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
  ContinueLoop           := Process32First(FSnapshotHandle, FProcessEntry32);
  while integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
      UpperCase(TaskName)) or (UpperCase(FProcessEntry32.szExeFile) =
      UpperCase(TaskName))) then
    begin
      Result := True;
      Break;
    end;
    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
end;

procedure TFormCnCFProcessing.SetFileName(const Value: string);
var
  fn: string;
begin
  if Value = EmptyStr then
    fn := 'Unknown'
  else
    fn := Extractfilename(Value);
  lblMsg.Caption := Format('Formatting File: %s', [fn]);
end;

procedure TFormCnCFProcessing.tmrFormattingTimer(Sender: TObject);
begin
  // done: check process exists?
  if not TaskExists('CnCodeFormat.exe') then
  begin
    tmrFormatting.Enabled := False;
    Close;
  end;
end;

end.
